MODULE highgui [ INTERFACE "C"; LINK LIB "highgui" END ];

IMPORT SYSTEM, cv;
CONST
  WINDOW_AUTOSIZE* = 1;
  EVENT_MOUSEMOVE* = 0;
  EVENT_LBUTTONDOWN* = 1;
  EVENT_RBUTTONDOWN* = 2;
  EVENT_MBUTTONDOWN* = 3;
  EVENT_LBUTTONUP* = 4;
  EVENT_RBUTTONUP* = 5;
  EVENT_MBUTTONUP* = 6;
  EVENT_LBUTTONDBLCLK* = 7;
  EVENT_RBUTTONDBLCLK* = 8;
  EVENT_MBUTTONDBLCLK* = 9;
  EVENT_FLAG_LBUTTON* = 1;
  EVENT_FLAG_RBUTTON* = 2;
  EVENT_FLAG_MBUTTON* = 4;
  EVENT_FLAG_CTRLKEY* = 8;
  EVENT_FLAG_SHIFTKEY* = 16;
  EVENT_FLAG_ALTKEY* = 32;
  CVTIMG_FLIP* = 1;
  CVTIMG_SWAP_RB* = 2;
  CAP_PROP_POS_MSEC* = 0;
  CAP_PROP_POS_FRAMES* = 1;
  CAP_PROP_POS_AVI_RATIO* = 2;
  CAP_PROP_FRAME_WIDTH* = 3;
  CAP_PROP_FRAME_HEIGHT* = 4;
  CAP_PROP_FPS* = 5;
  CAP_PROP_FOURCC* = 6;
  CAP_PROP_FRAME_COUNT* = 7;
  HG_AUTOSIZE* = 1;
TYPE
  CvCapture_tag* = RECORD END;
  CvVideoWriter_tag* = RECORD END;
  PtrCvVideoWriter* = POINTER TO CvVideoWriter;
  PtrCvCapture* = POINTER TO CvCapture;
  CvTrackbarCallback* = PROCEDURE(pos : LONGINT);
  CvMouseCallback* = PROCEDURE(event : LONGINT; x : LONGINT; y : LONGINT; flags : LONGINT);
  CvCapture* = RECORD END;
  CvVideoWriter* = RECORD END;
  PROCEDURE ["cvInitSystem"] InitSystem* (argc : LONGINT; argv : cv.Ptr1) : LONGINT;
  PROCEDURE ["cvNamedWindow"] NamedWindow* (name : cv.String; flags : LONGINT) : LONGINT;
  PROCEDURE ["cvShowImage"] ShowImage* (name : cv.String; image : cv.PtrCvArr);
  PROCEDURE ["cvResizeWindow"] ResizeWindow* (name : cv.String; width : LONGINT; height : LONGINT);
  PROCEDURE ["cvMoveWindow"] MoveWindow* (name : cv.String; x : LONGINT; y : LONGINT);
  PROCEDURE ["cvDestroyWindow"] DestroyWindow* (name : cv.String);
  PROCEDURE ["cvDestroyAllWindows"] DestroyAllWindows* ();
  PROCEDURE ["cvGetWindowHandle"] GetWindowHandle* (name : cv.String) : cv.Handle;
  PROCEDURE ["cvGetWindowName"] GetWindowName* (window_handle : cv.Handle) : cv.String;
  PROCEDURE ["cvCreateTrackbar"] CreateTrackbar* (trackbar_name : cv.String; window_name : cv.String; VAR value [NIL_COMPAT] : LONGINT; count : LONGINT; on_change : CvTrackbarCallback) : LONGINT;
  PROCEDURE ["cvGetTrackbarPos"] GetTrackbarPos* (trackbar_name : cv.String; window_name : cv.String) : LONGINT;
  PROCEDURE ["cvSetTrackbarPos"] SetTrackbarPos* (trackbar_name : cv.String; window_name : cv.String; pos : LONGINT);
  PROCEDURE ["cvSetMouseCallback"] SetMouseCallback* (window_name : cv.String; on_mouse : CvMouseCallback);
  PROCEDURE ["cvLoadImage"] LoadImage* (filename : cv.String; iscolor : LONGINT) : cv.PtrIplImage;
  PROCEDURE ["cvSaveImage"] SaveImage* (filename : cv.String; image : cv.PtrCvArr) : LONGINT;
  PROCEDURE ["cvConvertImage"] ConvertImage* (src : cv.PtrCvArr; dst : cv.PtrCvArr; flags : LONGINT);
  PROCEDURE ["cvWaitKey"] WaitKey* (delay : LONGINT) : LONGINT;
  PROCEDURE ["cvCaptureFromFile"] CaptureFromFile* (filename : cv.String) : PtrCvCapture;
  PROCEDURE ["cvCaptureFromCAM"] CaptureFromCAM* (index : LONGINT) : PtrCvCapture;
  PROCEDURE ["cvGrabFrame"] GrabFrame* (capture : PtrCvCapture) : LONGINT;
  PROCEDURE ["cvRetrieveFrame"] RetrieveFrame* (capture : PtrCvCapture) : cv.PtrIplImage;
  PROCEDURE ["cvQueryFrame"] QueryFrame* (capture : PtrCvCapture) : cv.PtrIplImage;
  PROCEDURE ["cvReleaseCapture"] ReleaseCapture* (VAR capture [NIL_COMPAT] : PtrCvCapture);
  PROCEDURE ["cvGetCaptureProperty"] GetCaptureProperty* (capture : PtrCvCapture; property_id : LONGINT) : LONGREAL;
  PROCEDURE ["cvSetCaptureProperty"] SetCaptureProperty* (capture : PtrCvCapture; property_id : LONGINT; value : LONGREAL) : LONGINT;
  (* PROCEDURE ["cvCreateVideoWriter"] CreateVideoWriter* (filename : cv.String; fourcc : LONGINT; fps : LONGREAL; frame_size : cv.CvSize) : PtrCvVideoWriter; *)
  PROCEDURE ["cvWriteFrame"] WriteFrame* (writer : PtrCvVideoWriter; image : cv.PtrIplImage) : LONGINT;
  PROCEDURE ["cvReleaseVideoWriter"] ReleaseVideoWriter* (VAR writer [NIL_COMPAT] : PtrCvVideoWriter);
END highgui.
