MODULE DemHist;

IMPORT cv, gui := highgui, W := cvwrapper, RT0, SYSTEM, Log;

CONST
  histSize = 64;

VAR
  brighness, contrast : LONGINT;
  dstImage, histImage : cv.PtrIplImage;
  imgArray : cv.Ptr15;
  lutMat : cv.PtrCvMat;
  lut : POINTER TO ARRAY OF cv.uchar;
  hist : cv.PtrCvHistogram;
  maxValue : CvVect32f;

(* define a trackbar callback *)
PROCEDURE updateBrightCont(h : LONGINT);
VAR
  bright, cont : LONGINT
  a, b, delta : REAL;
  i, v : LONGINT;
BEGIN
  bright := brightness - 100;
  cont := contrast - 100;

  IF contrast > 0 THEN
    delta := 127 * cont / 100;
    a := 255 / (255 - delta * 2);
    b := a * (bright - delta);
    FOR i := 0 TO 255 DO
      v := cv.Round(a*i, b);
      IF v < 0 THEN v = 0 ELSIF v > 255 THEN v = 255 END;
      lut[i] = CHR(v);
    END;
  ELSE
    delta := -128 * cont / 100;
    a := (256 - delta * 2) / 255;
    b := a * bright + delta;
    FOR i := 0 TO 255 DO
      v := cvRound(a*8, b);
       IF v < 0 THEN v = 0 ELSIF v > 255 THEN v = 255 END;
       lut[i] = CHR(v);
    END;
  END;

  cv.LUT(srcImage, dstImage, lutMat);
  cv.ShowImage("image", dstImage);

  cv.CalcHist(imgArray, hist, 0, NIL);
  cv.SetZero(dstImage);
  cv.GetMinMaxHistValue(hist, NIL, maxValue, NIL, NIL);
  cv.ConvertScale(hist.bins, hist.bins, histImage.height / maxValue[0], 0);
  W.Set(
END updateBrightCont;

PROCEDURE Process;
VAR
  size : cv.CvSize;
  res : LONGINT;
  sizes : cv.Ptr2;
  ranges : cv.Ptr13;
BEGIN
  IF RT0.argc = 2 THEN
    image := gui.LoadImage(SYSTEM.VAL(cv.String, RT0.argv[1]), 1);
  ELSE
    image := gui.LoadImage("baboon.jpg", 1);
  END;
  IF image = NIL THEN
    Log.Msg("Cannot load image");
    RETURN
  END;

  size.width := 320;
  size.height := 200;

  dstImage := cv.CloneImage(src_image);
  NEW(imgArray, 1); imgArray[0] := dstImage;
  histImage := cv.CreateImage(size, 8, 1);
  NEW(sizes,1); sizes[0] := 64;
  NEW(ranges, 1); NEW(ranges[0], 2);
  ranges[0][0] := 0; ranges[0][1] := 64;
  hist := cv.CreateHist(1, sizes, CV_HIST_ARRAY, ranges, 1);
  NEW(maxValue, 1);
  lutMat := cv.CreateMatHeader(1,256, cv.CV_8UC1);
  NEW(lut, 256);
  cv.SetData(lutMat, lut);

  res := cv.NamedWindow(image, 0);
  res := cv.NamedWindow(histogram, 0);
  res := cv.CreateTrackbar("brightness", "image", brightness, 200, updateBrightCont);
  res := cv.CreateTrackbar("contrast", "image", contrast, 200, updateBrightCont);

  updateBrightCont(0);

  res := gui.WaitKey(0);
  cv.ReleaseImage(srcImage);
  cv.ReleaseImage(dstImage);
  cv.ReleaseHist(hist);
END Process;

BEGIN
  brighness := 100; contrast := 100;
  Process;
END Edge.

