MODULE Edge;

IMPORT cv, gui := highgui, W := cvwrapper, RT0, SYSTEM, Log;

CONST
  wndName = "Edge";
  tbarname = "Threshold";

VAR
  image, cedge, edge, gray : cv.PtrIplImage;
  edge_thresh : LONGINT;

(* define a trackbar callback *)
PROCEDURE onTrackbar(h : LONGINT);
BEGIN
    cv.Smooth( gray, edge, cv.BLUR, 3, 3, 0 );
    cv.Not( gray, edge );

    (* Run the edge detector on grayscale *)
    cv.Canny(gray, edge, edge_thresh, edge_thresh*3, 3);
  
    cv.SetZero( cedge );
    (* copy edge points *)
    cv.Copy( image, cedge, edge );

    gui.ShowImage(wndName, cedge);
END onTrackbar;

PROCEDURE Process;
VAR
  size : cv.CvSize;
  res : LONGINT;
BEGIN
  IF RT0.argc = 2 THEN
    image := gui.LoadImage(SYSTEM.VAL(cv.String, RT0.argv[1]), 1);
  ELSE
    image := gui.LoadImage("fruits.jpg", 1);
  END;
  IF image = NIL THEN
    Log.Msg("Cannot load image");
    RETURN
  END;

  size.width := image.width;
  size.height := image.height;

  cedge := W.CreateImage(size, cv.IPL_DEPTH_8U, 3);
  gray := W.CreateImage(size, cv.IPL_DEPTH_8U, 1);
  edge := W.CreateImage(size, cv.IPL_DEPTH_8U, 1);
  cv.CvtColor(image, gray, cv.BGR2GRAY);

  res := gui.NamedWindow(wndName, 1);
  res := gui.CreateTrackbar(tbarname, wndName, edge_thresh, 100, onTrackbar);

  onTrackbar(0);

  res := gui.WaitKey(0);
  cv.ReleaseImage(image);
  cv.ReleaseImage(gray);
  cv.ReleaseImage(edge);
  gui.DestroyWindow(wndName);
END Process;

BEGIN
  edge_thresh := 1;
  Process;
END Edge.

