MODULE VideoFromFile;

IMPORT cv, gui := highgui, RT0, SYSTEM, Log, Out;

CONST
  wndName = "Video Window";
  barName = "Position";

VAR
  video : gui.PtrCvCapture;
  pos : LONGINT;

PROCEDURE handleTrackbar(val : LONGINT);
VAR
  image : cv.PtrIplImage;
  res : LONGINT;
  ratio : LONGREAL;
BEGIN
  ratio := val / 1000.0;
  Log.LongReal("setRatio", ratio);
  res := gui.SetCaptureProperty(video, gui.CAP_PROP_POS_AVI_RATIO, ratio);
  Log.LongReal("getRatio", gui.GetCaptureProperty(video, gui.CAP_PROP_POS_AVI_RATIO));
  Log.LongInt("SetCaptureProperty", res);
  image := gui.QueryFrame(video);
  gui.ShowImage(wndName, image);
END handleTrackbar;

PROCEDURE Test;
VAR
  size : cv.CvSize;
  image : cv.PtrIplImage;
  res : LONGINT;
BEGIN
  IF RT0.argc # 2 THEN
    Log.Msg("usage: VideoFromFile <filename>"); RETURN;
  END;

  video := gui.CaptureFromFile(SYSTEM.VAL(cv.String, RT0.argv[1]));
  IF video = NIL THEN
    Log.Msg("Cannot open video source"); RETURN;
  END;

  size.width := ENTIER(gui.GetCaptureProperty(video, gui.CAP_PROP_FRAME_WIDTH));
  size.height := ENTIER(gui.GetCaptureProperty(video, gui.CAP_PROP_FRAME_HEIGHT));

  Log.LongInt("width", size.width);
  Log.LongInt("height", size.height);

  res := gui.NamedWindow(wndName, gui.WINDOW_AUTOSIZE);
(*  res := gui.CreateTrackbar(barName, wndName, pos, 1000, handleTrackbar); *)

  res := gui.SetCaptureProperty(video, gui.CAP_PROP_POS_AVI_RATIO, 0.5);
  Log.LongInt("SetCaptureProperty", res);
  image := gui.QueryFrame(video);
  WHILE image # NIL DO
    gui.ShowImage(wndName, image);
  Log.LongReal("getRatio", gui.GetCaptureProperty(video, gui.CAP_PROP_POS_AVI_RATIO));
    res := gui.WaitKey(10);
    image := gui.QueryFrame(video);
  END;
    
(*  handleTrackbar(0);
  res := gui.WaitKey(0); *)
  gui.DestroyWindow(wndName);
END Test;

BEGIN
  pos := 0;
  Test;
END VideoFromFile.

