MODULE TestGL1;

IMPORT Glut, Glu, Gl, RT0, Log, SYSTEM;

PROCEDURE Display;
BEGIN
(* clear all pixels *)
  Gl.Clear (Gl.COLOR_BUFFER_BIT);

(* draw white polygon (rectangle) with corners at
 * (0.25, 0.25, 0.0) and (0.75, 0.75, 0.0) *)

  Gl.Color3f (1.0, 1.0, 1.0);
  Gl.Begin(Gl.POLYGON);
  Gl.Vertex3f (0.25, 0.25, 0.0);
  Gl.Vertex3f (0.75, 0.25, 0.0);
  Gl.Vertex3f (0.75, 0.75, 0.0);
  Gl.Vertex3f (0.25, 0.75, 0.0);
  Gl.End();

(* don't wait! start processing buffered OpenGL routines *)

  Gl.Flush ();
END Display;

PROCEDURE Init;
BEGIN
(* select clearing (background) color *)
  Gl.ClearColor (0.0, 0.0, 0.0, 0.0);
(* initialize viewing values *)
  Gl.MatrixMode(Gl.PROJECTION);
  Gl.LoadIdentity();
  Gl.Ortho(0.0, 1.0, 0.0, 1.0, -1.0, 1.0);
END Init;

(*
* Declare initial window size, position, and display mode
* (single buffer and RGBA). Open window with "hello"
* in its title bar. Call initialization routines.
* Register callback function to display graphics.
* Enter main loop and process events.
*)

PROCEDURE Main;
VAR
  argc : LONGINT;
  argv : Glut.StringArray;
BEGIN
  argc := RT0.argc;
  argv := SYSTEM.VAL(Glut.StringArray, RT0.argv);
  Glut.Init(argc, argv);
  Glut.InitDisplayMode (Glut.SINGLE + Glut.RGB);
  Glut.InitWindowSize (250, 250);
  Glut.InitWindowPosition (100, 100);
  Log.Int("Create", Glut.CreateWindow ("hello"));
  Init;
  Glut.DisplayFunc(Display);
  Glut.MainLoop();
END Main;

BEGIN
  Main;
END TestGL1.
