MODULE TestGL2;

IMPORT Glut, Gl, RT0, Log, SYSTEM;

VAR
  spin : Gl.float;
  spin2 : Gl.float;

PROCEDURE Init;
BEGIN
  Gl.ClearColor (0.0, 0.0, 0.0, 0.0);
  Gl.ShadeModel(Gl.FLAT);
END Init;

PROCEDURE Display;
BEGIN
  Gl.Clear (Gl.COLOR_BUFFER_BIT);
  Gl.PushMatrix();
  Gl.Rotatef(spin, 0.0, 0.0, 1.0);
  Gl.Rotatef(spin2, 0.0, 1.0, 0.0);
  Gl.Color3f(1.0, 1.0, 1.0);
(*  Gl.Rectf(-25.0, -25.0, 25.0, 25.0); *)
(*  Glut.WireIcosahedron(); *)
  Glut.WireTeapot(1.0);
  Gl.PopMatrix();
  Glut.SwapBuffers();
END Display;

PROCEDURE SpinDisplay;
BEGIN
  spin := spin + 2.0;
  IF spin > 360.0 THEN spin := spin - 360.0; END;
  spin2 := spin2 + 1.0;
  IF spin2 > 360.0 THEN spin2 := spin2 - 360.0; END;
  Glut.PostRedisplay;
END SpinDisplay;

PROCEDURE Reshape(w, h : LONGINT);
BEGIN
  Gl.Viewport (0, 0, w, h);
  Gl.MatrixMode(Gl.PROJECTION);
  Gl.LoadIdentity();
  Gl.Ortho(-2.0, 2.0, -2.0, 2.0, -2.0, 2.0);
  Gl.MatrixMode(Gl.MODELVIEW);
  Gl.LoadIdentity();
END Reshape;

PROCEDURE Mouse(button, state, x, y : LONGINT);
BEGIN
  CASE button OF
  | Glut.LEFT_BUTTON:
    IF state = Glut.DOWN THEN
      Glut.IdleFunc(SpinDisplay)
    END;
  | Glut.RIGHT_BUTTON:
    IF state = Glut.DOWN THEN
      Glut.IdleFunc(NIL)
    END
  ELSE
  END;
END Mouse;

(*
* Request double buffer display mode.
* Register mouse input callback functions
*)

PROCEDURE Main;
VAR
  argc : LONGINT;
  argv : Glut.StringArray;
BEGIN
  argc := RT0.argc;
  argv := SYSTEM.VAL(Glut.StringArray, RT0.argv);
  Glut.Init(argc, argv);
  Glut.InitDisplayMode (Glut.DOUBLE + Glut.RGB);
  Glut.InitWindowSize (250, 250);
  Glut.InitWindowPosition (100, 100);
  Log.Int("Create", Glut.CreateWindow ("hello"));
  Init;
  Glut.DisplayFunc(Display);
  Glut.ReshapeFunc(Reshape);
  Glut.MouseFunc(Mouse);
  Glut.MainLoop();
END Main;

BEGIN
  spin := 0.0;
  spin2 := 0.0;
  Main;
END TestGL2.
